# $Id: contents.bro,v 1.4 2004/03/10 21:44:55 vern Exp $

redef capture_filters += { ["contents"] = "tcp" };

# Keeps track of how many times we've decided to write to a given
# contents file.  All we really want to know is whether we've ever
# written to it before, because if so, then for future uses we
# append to the file rather than overwrite it.
global contents_files: table[string] of count &default = 0;

event new_connection_contents(c: connection)
	{
	local id = c$id;

	local orig_file =
		fmt("contents.%s.%d-%s.%d",
			id$orig_h, id$orig_p, id$resp_h, id$resp_p);
	local resp_file =
		fmt("contents.%s.%d-%s.%d",
			id$resp_h, id$resp_p, id$orig_h, id$orig_p);

	local orig_f: file;
	local resp_f: file;

	if ( ++contents_files[orig_file] == 1 )
		orig_f = open(orig_file);
	else
		orig_f = open_for_append(orig_file);

	if ( ++contents_files[resp_file] == 1 )
		resp_f = open(resp_file);
	else
		resp_f = open_for_append(resp_file);

	set_contents_file(id, CONTENTS_ORIG, orig_f);
	set_contents_file(id, CONTENTS_RESP, resp_f);
	}
